package require nsmhash

puts [ns_mhash hash algorithms]



set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
ns_mhash hash destroy $td

set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
set out [ns_mhash hash end -base64 $td]
puts $out


set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
set out [ns_mhash hash end $td]
puts $out

set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set td2 [ns_mhash hash copy $td]
set out [ns_mhash hash end $td]
ns_mhash hash update $td2 " "
ns_mhash hash update $td2 "world"
set out2 [ns_mhash hash end $td2]
puts $out
puts $out2


set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set detachid [ns_mhash hash detach $td]
set test_test $detachid
set detachid $test_test
set td [ns_mhash hash attach $detachid]
ns_mhash hash update $td " "
ns_mhash hash update $td "world"
set out [ns_mhash hash end $td]
puts $out

set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set serializestr [ns_mhash hash serialize $td]
set test_test $serializestr
set serializestr $test_test
set td [ns_mhash hash unserialize $serializestr]
ns_mhash hash update $td " world"
set out [ns_mhash hash end $td]
puts $out
puts $serializestr

set td [ns_mhash hash new MD5]
set fp [open ../test.bin]
fconfigure $fp -translation binary -encoding binary
while {![eof $fp]} {
    ns_mhash hash update $td [read $fp 1]
}
close $fp
set out [ns_mhash hash end $td]

puts "$out =  4bb051067c1f931b6adf55d1161abfac"
