package require nsmhash

puts [ns_mhash hmac algorithms]


set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
ns_mhash hmac destroy $td

set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
set out [ns_mhash hmac end -base64 $td]
puts $out


set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
set out [ns_mhash hmac end $td]
puts $out

set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello"
set td2 [ns_mhash hmac copy $td]
set out [ns_mhash hmac end $td]
ns_mhash hmac update $td2 " "
ns_mhash hmac update $td2 "world"
set out2 [ns_mhash hmac end $td2]
puts $out
puts $out2

set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello"
set detachid [ns_mhash hmac detach $td]
set test_test $detachid
set detachid $test_test
set td [ns_mhash hmac attach $detachid]
ns_mhash hmac update $td " "
ns_mhash hmac update $td "world"
set out [ns_mhash hmac end $td]
puts $out

